﻿using System;
using System.Collections;
using System.Globalization;
using System.Text;
using System.Windows.Forms;

namespace lab1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            comboBox_faultNumber.DataSource = new[] { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13 };
            comboBox_faultType.DataSource = new[] { "≡1", "≡0" };
        }

        private const int InputsNumber = 7;


        private void button_start_Click(object sender, EventArgs e)
        {
            int combinationsNumber = (int) Math.Pow(2, InputsNumber);

            int faultNumber = int.Parse(comboBox_faultNumber.Text);
            bool faultType = comboBox_faultType.Text == @"≡1";

            listView1.Items.Clear();

            for (byte i = 0; i < combinationsNumber; i++)
            {
                BitArray inputsArray = new BitArray(new byte[] {i}) {Length = InputsNumber};

                bool correctResult = CalculateSet(inputsArray);
                bool result = CalculateSet(inputsArray, faultNumber, faultType);

                if (result == correctResult) continue;

                string bitSetString = BitArrayToString(inputsArray);

                listView1.Items.Add(new ListViewItem(new[] {bitSetString, 
                    Convert.ToInt16(correctResult).ToString(CultureInfo.InvariantCulture)}));
            }
        }

        private bool CalculateSet(BitArray inputs, int faultNumber = -1, bool faultType = false)
        {
            bool tmp = false;
            if (faultNumber >= 1 && faultNumber <= 7)
            {
                tmp = inputs[faultNumber - 1];
                inputs[faultNumber - 1] = faultType; 
            }
                
            bool f1 = !(inputs[0] | inputs[1]);
            bool f2 = !inputs[2];
            bool f3 = !(inputs[4] & inputs[5]);


            bool f4, f5, f6;

            if (faultNumber == 10)      f4 = (inputs[3] & faultType & inputs[6]);
            else                        f4 = (inputs[3] & f3 & inputs[6]);


            if (faultNumber == 9)       f5 = faultType | f4;
            else if (faultNumber == 11) f5 = f2 | faultType;
            else                        f5 = f2 | f4;

            if (faultNumber == 12)      f6 = f1 & faultType;
            else if (faultNumber == 8)  f6 = faultType & f5;
            else                        f6 = f1 & f5;

            if (faultNumber == 13)
                f6 = faultType;

            if (faultNumber >= 1 && faultNumber <= 7)   // Возвращаем изменённое значение бита (если меняли)
                inputs[faultNumber - 1] = tmp;

            return f6;
        }

        private string ReverseBitArrayToString(BitArray array)
        {
            var sb = new StringBuilder();
            for (var i = array.Length - 1; i >= 0; i--)
                sb.Append(array[i] ? "1 " : "0 ");

            return sb.ToString();
        }

        private string BitArrayToString(BitArray array)
        {
            var sb = new StringBuilder();
            for (var i = 0; i < array.Length; i++)
            {
                sb.Append(array[i] ? "1 " : "0 ");
            }

            return sb.ToString();
        }
    }
}
