﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace lab2
{
    class D_Algorithm
    {
        public List<Symbol[]> FindResultCube(int elementNumber, bool isHigh)
        {
            List<Element> elementsList = GenerateElementsList(elementNumber, isHigh);   // Список элементов            

            List<Symbol[]> resultCubeList = new List<Symbol[]>();

            Symbol[] currentCube = new Symbol[13];
            Symbol[] bufferCube = new Symbol[13];

            reinitializeCube(currentCube);

            int i = 0, j = 0;

            while (true)
            {
                // Если прошли все элементы из списка
                if (i >= elementsList.Count)
                {
                    resultCubeList.Add(currentCube);                // Добавляем полученный набор к списку результатов
                    i--;    // Переходим к предыдущему элементу
                    currentCube = elementsList[i].getSavedCube();   // Получаем куб до последнего пересечения с кубами элемента
                }

                elementsList[i].setSavedCube(currentCube);      // Сохраняем предыдущий куб

                bool isMoreCubes = elementsList[i].getNextCube(ref bufferCube);

                if (isMoreCubes == true)  // Остались не переченные кубы
                {
                    bufferCube = DCube_Intersection(currentCube, bufferCube);

                    if (bufferCube != null)     // Есть результат пересечения
                    {
                        currentCube = bufferCube;
                        i++;                        // Переходим к следующему элементу
                    }
                    else            // В результате пересечения получилось пустое множество          
                        continue;   // Пробуем с другим кубом данного элемента                 
                }
                else  // Все кубы в элементе использованы
                {
                    j = i - 1;
                    while (j >= 0 && elementsList[j].isLastCube())                    
                        j--;
                    
                    if (j < 0) 
                        break;   // Если все кубы предыдущих элементов использованы, то все тестовые наборы найдены

                    currentCube = elementsList[--i].getSavedCube(); // Переходим к предыдущему элементу
                }
            }
            return resultCubeList;
        }


        // Сформировать список элементов для последовательного пересечения из d-кубов 
        // в зависимости от номера неисправного элемента
        List<Element> GenerateElementsList(int elementNumber, bool faultType)
        {
            List<Element> elementsList = new List<Element>();

            CubeType d_cube_fault = faultType ? CubeType.D_fault_1 : CubeType.D_fault_0;

            switch (elementNumber)
            {
                case 1:
                    elementsList.Add(new F1(d_cube_fault));
                    elementsList.Add(new F6(CubeType.D));
                    elementsList.Add(new F2(CubeType.Singular));
                    elementsList.Add(new F3(CubeType.Singular));
                    elementsList.Add(new F4(CubeType.Singular));
                    elementsList.Add(new F5(CubeType.Singular));
                    break;
                case 2:
                    elementsList.Add(new F2(d_cube_fault));
                    elementsList.Add(new F5(CubeType.D));
                    elementsList.Add(new F6(CubeType.D));
                    elementsList.Add(new F1(CubeType.Singular));
                    elementsList.Add(new F3(CubeType.Singular));
                    elementsList.Add(new F4(CubeType.Singular));
                    break;
                case 3:
                    elementsList.Add(new F3(d_cube_fault));
                    elementsList.Add(new F4(CubeType.D));
                    elementsList.Add(new F5(CubeType.D));
                    elementsList.Add(new F6(CubeType.D));
                    elementsList.Add(new F1(CubeType.Singular));
                    elementsList.Add(new F2(CubeType.Singular));
                    break;
                case 4:
                    elementsList.Add(new F4(d_cube_fault));
                    elementsList.Add(new F5(CubeType.D));
                    elementsList.Add(new F6(CubeType.D));
                    elementsList.Add(new F1(CubeType.Singular));
                    elementsList.Add(new F2(CubeType.Singular));
                    elementsList.Add(new F3(CubeType.Singular));
                    break;
                case 5:
                    elementsList.Add(new F5(d_cube_fault));
                    elementsList.Add(new F6(CubeType.D));
                    elementsList.Add(new F1(CubeType.Singular));
                    elementsList.Add(new F2(CubeType.Singular));
                    elementsList.Add(new F4(CubeType.Singular));
                    elementsList.Add(new F3(CubeType.Singular));
                    break;
                case 6:
                    elementsList.Add(new F6(d_cube_fault));
                    elementsList.Add(new F1(CubeType.Singular));
                    elementsList.Add(new F2(CubeType.Singular));
                    elementsList.Add(new F5(CubeType.Singular));
                    elementsList.Add(new F4(CubeType.Singular));
                    elementsList.Add(new F3(CubeType.Singular));
                    break;
            }

            return elementsList;
        }

        // Операция пересечения d-кубов
        private Symbol[] DCube_Intersection(Symbol[] dCube1, Symbol[] dCube2)
        {
            Symbol[] result_dCube = new Symbol[13];
            for (int i = 0; i < 13; i++)
            {
                result_dCube[i] = IntersectionOfDSymbols(dCube1[i], dCube2[i]);
                if (result_dCube[i] == Symbol.Empty)
                    return null;
            }
            return result_dCube;
        }

        // Пересечение отдельных символов d-кубов
        private Symbol IntersectionOfDSymbols(Symbol n1, Symbol n2)
        {
            if (n2 == n1 || n2 == Symbol.X)
                return n1;
            if (n1 == n2 || n1 == Symbol.X)
                return n2;

            return Symbol.Empty;
        }

        // Заполнить куб безразличными символами
        private void reinitializeCube(Symbol[] n)
        {
            for (int i = 0; i < n.Length; i++)
                n[i] = Symbol.X;
        }
    }
}
