﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace lab3
{

    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button_start_Click(object sender, EventArgs e)
        {
            ClearListViews();

            Tests tests = new Tests(7, 13);
            tests.FindAll();

            Cover[] coversArray = tests.coversArray;         // Получаем покрытия для всех входных комбинаций
            ShowCoversToListView(coversArray, listView_combinations, true);

            Cover[] minCoversArray = tests.minCoversArray;           // Получаем мин. число тестов для полного покрытия
            ShowCoversToListView(minCoversArray, listView_tests100cover, false);

            bool[][] nodesStatesArray = tests.defaultNodesStatesArray;          
            ShowSwitchCountToListView(nodesStatesArray, listView_testsSwitch);      // Выводим число переключений для последовательности тестов

            // Получаем оптимальную перестановку тестов для минимального числа переключений
            bool[][] optimalNodesStatesArray = tests.optimalNodesStatesArray;
            ShowSwitchCountToListView(optimalNodesStatesArray, listView_testsOptimalSwitch);


            double badPower = tests.switchCountBad * 0.59895 * Math.Pow(10, -10) / tests.minTestNumber / Math.Pow(10, -7);
            double optPower = tests.switchCountOptimal * 0.59895 * Math.Pow(10, -10) / tests.minTestNumber / Math.Pow(10, -7);

            textBox_minSwitchCount.Text = tests.switchCountOptimal.ToString();
            textBox_minTestsCount.Text = tests.minTestNumber.ToString();
            textBox_badPower.Text = badPower.ToString("0.###E+0", CultureInfo.InvariantCulture);
            textBox_power.Text = optPower.ToString("0.###E+0", CultureInfo.InvariantCulture);
        }
                 

        //----------------------------------------------------------------------
        //----------------------------------------------------------------------
        //----------------------------------------------------------------------

        private void ShowCoversToListView(Cover[] coversArray, ListView listView, bool isShowCount)
        {
            for (int i = 0; i < coversArray.Length; i++)
            {
                string num = (i + 1).ToString();
                string input = BoolArrayToString(coversArray[i].inputs, "1 ", "0 ");
                string faults;
                if (isShowCount)
                    faults = coversArray[i].faultCover.Count(k => k != false).ToString();
                else
                    faults = BoolArrayToString(coversArray[i].faultCover, "1 ", "0 ");

                string[] item = new string[]{num, input, faults};

                listView.Items.Add(new ListViewItem(item));
            }
        }

        private void ShowSwitchCountToListView(bool[][] nodesStatesArray, ListView listView)
        {
            bool[] prevStates = nodesStatesArray[0];
            bool[] newStates;

            string numStr = "1";
            string statesStr = BoolArrayToString(nodesStatesArray[0], "1 ", "0 ");
            string switchCountStr = "";

            listView.Items.Add(new ListViewItem(new[] { numStr, statesStr, switchCountStr }));

            int fullSwitchCount = 0;
            for (int i = 1; i <= nodesStatesArray.Length; i++)
            {
                if (i == nodesStatesArray.Length)
                {
                    newStates = nodesStatesArray[0];
                    numStr = "1";
                    statesStr = BoolArrayToString(nodesStatesArray[0], "1 ", "0 ");
                }
                else
                {
                    newStates = nodesStatesArray[i];
                    numStr = (i + 1).ToString();
                    statesStr = BoolArrayToString(nodesStatesArray[i], "1 ", "0 ");
                }
                int switchCount = Tests.GetSwitchesCount(prevStates, newStates);
                fullSwitchCount += switchCount;

                switchCountStr = switchCount.ToString();                

                listView.Items.Add(new ListViewItem(new[] { numStr, statesStr, switchCountStr }));
                prevStates = newStates;
            }
            listView.Items.Add(new ListViewItem(new[] { "", "Всего: ", fullSwitchCount.ToString() }));
        }
        

        private string BoolArrayToString(bool[] array, string trueSymbol = "1", string falseSymbol = "0")
        {
            var sb = new StringBuilder();
            for (var i = 0; i < array.Length; i++)
            {
                sb.Append(array[i] ? trueSymbol : falseSymbol);
            }

            return sb.ToString();
        }


        private void ClearListViews()
        {
            listView_combinations.Items.Clear();
            listView_tests100cover.Items.Clear();
            listView_testsOptimalSwitch.Items.Clear();
            listView_testsSwitch.Items.Clear();
        }
    }
}
