﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace lab5_LFSR
{
    class LFSR
    {
        private int[] members;

        public LFSR(int[] members)
        {
            this.members = members;
        }

        private bool CalculateFirstValue(bool[] values)
        {
            return members.Aggregate(false, (current, member) => current ^ values[member]);
        }

        public bool[] GetNext(bool[] current)
        {
            bool[] result = new bool[current.Count()];

            result[0] = CalculateFirstValue(current);

            for (int i = 1; i < current.Length; i++)            
                result[i] = current[i - 1];
            
            return result;
        }
    }
}
