﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace kidsvt_lab5_SA
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        const int nodesNumber = 13;                 // Количество полюсов схемы
        const int faultNumber = nodesNumber * 2;    // Количество неисправностей

        const int signatureAnalyzer_length = 8;
        const int maxCyclesCount = 128;


        List<int[]> signatureAnalyzerPolynomList = new List<int[]>
                               {
                                   new [] {3, 2},
                                   new [] {3, 1},
                                   new [] {4, 3},
                                   new [] {4, 1},
                                   new [] {5, 3},
                                   new [] {5, 2},
                                   new [] {5, 4, 3, 2},
                                   new [] {5, 4, 3, 1},
                                   new [] {5, 4, 2, 1},
                                   new [] {5, 3, 2, 1},
                                   new [] {6, 5},
                                   new [] {6, 5, 4, 2},
                                   new [] {6, 5, 3, 2},
                                   new [] {6, 1},
                                   new [] {6, 5, 4, 1},
                                   new [] {6, 4, 3, 1},
                                   new [] {6, 5, 2, 1},
                                   new [] {6, 4, 2, 1},
                                   new [] {7, 1},
                                   new [] {7, 5, 3, 1},
                                   new [] {7, 5, 4, 3},
                                   new [] {7, 6, 5, 4, 2, 1},
                                   new [] {7, 6, 5, 2},
                                   new [] {7, 4},
                                   new [] {7, 6, 5, 4},
                                   new [] {7, 6, 5, 4, 3, 2},
                                   new [] {7, 6, 3, 1},
                                   new [] {7, 6},
                                   new [] {7, 6, 4, 2},
                                   new [] {7, 4, 3, 2},
                                   new [] {7, 6, 5, 3, 2, 1},
                                   new [] {7, 5, 2, 1},
                                   new [] {7, 3},
                                   new [] {7, 3, 2, 1},
                                   new [] {7, 5, 4, 3, 2, 1},
                                   new [] {7, 6, 4, 1},
                                   new [] {8, 7, 6, 5, 4, 1},
                                   new [] {8, 6, 5, 4},
                                   new [] {8, 5, 3, 2},
                                   new [] {8, 6, 3, 2},
                                   new [] {8, 7, 6, 3, 2, 1},
                                   new [] {8, 7, 6, 1},
                                   new [] {8, 6, 5, 1},
                                   new [] {8, 5, 3, 1},
                                   new [] {8, 7, 6, 5, 4, 2},
                               };




        private void start_button_Click(object sender, EventArgs e)
        {
            LFSR lfsr = new LFSR(new int[] { 7, 5, 3, 1 }, 
                                new bool[] {false, false, true, false, true, false, false});

            var infoList = SignatureAnalyzer.GetSignatureAnalyzerStatistics(signatureAnalyzerPolynomList, 
                                                                                  lfsr, signatureAnalyzer_length, maxCyclesCount);
            int minXOR_count = int.MaxValue;
            for (int i = 0; i < signatureAnalyzerPolynomList.Count; i++)
            {
                if (signatureAnalyzerPolynomList[i].Length < minXOR_count)
                    minXOR_count = signatureAnalyzerPolynomList[i].Length;
            }



            foreach (var info in infoList)
            {
                string[] rowStrs = 
                    new string[] { PolynomialToString(info.polynomial), info.XOR_count.ToString(), info.percent.ToString() };


                dataGridView1.Rows.Add(rowStrs);
                if(info.XOR_count == minXOR_count && info.percent == 100.0)
                {
                    DataGridViewCellStyle style = new DataGridViewCellStyle();
                    style.Font = new Font(dataGridView1.Columns[0].DefaultCellStyle.Font, FontStyle.Bold);
                    dataGridView1.Rows[dataGridView1.RowCount - 1].DefaultCellStyle = style;
                }
            }   
        }

        

        private static string PolynomialToString(int[] polynomial)
        {
            StringBuilder sb = new StringBuilder(40);

            for (int i = 0; i < polynomial.Length; i++)
            {
                sb.Append("x^");
                sb.Append(polynomial[i]);
                sb.Append('⊕');
            }
            sb.Append('1');

            return sb.ToString();
        }
    
    }
}
