﻿using System;
using System.Collections.Generic;

namespace kidsvt_lab7_8
{
    class MemoryTests
    {
        public static int Galpat(MemoryUnit memoryUnit)
        {
            HashSet<MemoryCell> faultyCells = new HashSet<MemoryCell>();

            GalpatSubTest(memoryUnit, faultyCells, true);
            GalpatSubTest(memoryUnit, faultyCells, false);

            return faultyCells.Count;
        }


        private static void GalpatSubTest(MemoryUnit memoryUnit, HashSet<MemoryCell> faultyCells, bool testValue)
        {
            bool backgroundValue = !testValue;

            WriteBackgroundValue(memoryUnit, backgroundValue);

            for (int i = 0; i < memoryUnit.NumberOfRows; i++)
            {
                for (int j = 0; j < memoryUnit.NumberOfColumns; j++)
                {
                    memoryUnit.SetMemoryCellValue(i, j, testValue);

                    for (int a = 0; a < memoryUnit.NumberOfRows; a++)
                    {
                        for (int b = 0; b < memoryUnit.NumberOfColumns; b++)
                        {
                            if (i == a && j == b) continue;

                            bool currentBackgroundValue = memoryUnit.GetMemoryCellValue(a, b);
                            bool currentTestValue = memoryUnit.GetMemoryCellValue(i, j);

                            if (currentBackgroundValue != backgroundValue)
                                faultyCells.Add(new MemoryCell(a, b));
                            if (currentTestValue != testValue)
                                faultyCells.Add(new MemoryCell(i, j));
                        }
                    }
                    memoryUnit.SetMemoryCellValue(i, j, !testValue);
                }
            }
        }

        public static int Mats(MemoryUnit memoryUnit)
        {
            HashSet<MemoryCell> faultyCells = new HashSet<MemoryCell>();

            WriteBackgroundValue(memoryUnit, false);

            for (int i = 0; i < memoryUnit.NumberOfRows; i++)
            {
                for (int j = 0; j < memoryUnit.NumberOfColumns; j++)
                {
                    bool value = memoryUnit.GetMemoryCellValue(i, j);
                    if(value != false)
                        faultyCells.Add(new MemoryCell(i, j));

                    memoryUnit.SetMemoryCellValue(i, j, true);
                }
            }

            for (int i = 0; i < memoryUnit.NumberOfRows; i++)
            {
                for (int j = 0; j < memoryUnit.NumberOfColumns; j++)
                {
                    bool value = memoryUnit.GetMemoryCellValue(i, j);
                    if (value != true)
                        faultyCells.Add(new MemoryCell(i, j));
                }
            }

            return faultyCells.Count;
        }


        public static int March_PS(MemoryUnit memoryUnit)
        {
            HashSet<MemoryCell> faultyCells = new HashSet<MemoryCell>();

            WriteBackgroundValue(memoryUnit, false);

            for (int i = 0; i < memoryUnit.NumberOfRows; i++)
            {
                for (int j = 0; j < memoryUnit.NumberOfColumns; j++)
                {
                    bool value = memoryUnit.GetMemoryCellValue(i, j);
                    if (value != false)
                        faultyCells.Add(new MemoryCell(i, j));

                    memoryUnit.SetMemoryCellValue(i, j, true);
                    value = memoryUnit.GetMemoryCellValue(i, j);
                    if (value != true)
                        faultyCells.Add(new MemoryCell(i, j));

                    memoryUnit.SetMemoryCellValue(i, j, false);
                    value = memoryUnit.GetMemoryCellValue(i, j);
                    if (value != false)
                        faultyCells.Add(new MemoryCell(i, j));

                    memoryUnit.SetMemoryCellValue(i, j, true);
                }
            }

            for (int i = 0; i < memoryUnit.NumberOfRows; i++)
            {
                for (int j = 0; j < memoryUnit.NumberOfColumns; j++)
                {
                    bool value = memoryUnit.GetMemoryCellValue(i, j);
                    if (value != true)
                        faultyCells.Add(new MemoryCell(i, j));

                    memoryUnit.SetMemoryCellValue(i, j, false);
                    value = memoryUnit.GetMemoryCellValue(i, j);
                    if (value != false)
                        faultyCells.Add(new MemoryCell(i, j));

                    memoryUnit.SetMemoryCellValue(i, j, true);
                    value = memoryUnit.GetMemoryCellValue(i, j);
                    if (value != true)
                        faultyCells.Add(new MemoryCell(i, j));
                }
            }

            for (int i = 0; i < memoryUnit.NumberOfRows; i++)
            {
                for (int j = 0; j < memoryUnit.NumberOfColumns; j++)
                {
                    bool value = memoryUnit.GetMemoryCellValue(i, j);
                    if (value != true)
                        faultyCells.Add(new MemoryCell(i, j));

                    memoryUnit.SetMemoryCellValue(i, j, false);
                    value = memoryUnit.GetMemoryCellValue(i, j);
                    if (value != false)
                        faultyCells.Add(new MemoryCell(i, j));

                    memoryUnit.SetMemoryCellValue(i, j, true);
                    value = memoryUnit.GetMemoryCellValue(i, j);
                    if (value != true)
                        faultyCells.Add(new MemoryCell(i, j));

                    memoryUnit.SetMemoryCellValue(i, j, false);
                }
            }

            for (int i = 0; i < memoryUnit.NumberOfRows; i++)
            {
                for (int j = 0; j < memoryUnit.NumberOfColumns; j++)
                {
                    bool value = memoryUnit.GetMemoryCellValue(i, j);
                    if (value != false)
                        faultyCells.Add(new MemoryCell(i, j));

                    memoryUnit.SetMemoryCellValue(i, j, true);
                    value = memoryUnit.GetMemoryCellValue(i, j);
                    if (value != true)
                        faultyCells.Add(new MemoryCell(i, j));

                    memoryUnit.SetMemoryCellValue(i, j, false);
                    value = memoryUnit.GetMemoryCellValue(i, j);
                    if (value != false)
                        faultyCells.Add(new MemoryCell(i, j));
                }
            }

            return faultyCells.Count;
        }


        public static void WriteBackgroundValue(MemoryUnit memoryUnit, bool value)
        {
            for (int i = 0; i < memoryUnit.NumberOfRows; i++)
            {
                for (int j = 0; j < memoryUnit.NumberOfColumns; j++)
                    memoryUnit.SetMemoryCellValue(i, j, value);
            }
        }

        private static void Shuffle<T>(IList<T> array)
        {
            var random = new Random();
            for (int i = array.Count; i > 1; i--)
            {
                // Pick random element to swap.
                int j = random.Next(i); // 0 <= j <= i-1
                // Swap.
                T tmp = array[j];
                array[j] = array[i - 1];
                array[i - 1] = tmp;
            }
        }
    }
}
